////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef CUSTOM_EFFECT_GRAPHIC_OBJECTS_H_INCLUDED
#define CUSTOM_EFFECT_GRAPHIC_OBJECTS_H_INCLUDED

#include <gtf/scdr/ConstantBuffer.h>
#include <gtf/scdr/ResourceBindingTable.h>
#include <gtf/scdr/PipelineStateObject.h>
#include <gtf/scdr/VertexBuffer.h>

struct ImageVariable
{
    uint16_t handle;
    uint16_t slot;
};

struct ScalarUniformVariable
{
    uint16_t            handle;
    uint16_t            offset;
    gtf::type::TypeId::typeId_t type;
};

struct CustomEffectGraphicObjects
{
    gtf::scdr::ResourceBindingTable* resourceBindingTable;
    gtf::scdr::PipelineStateObject*  pipelineStateObject;
    gtf::scdr::ConstantBuffer*       uniforms;
    gtf::scdr::VertexBuffer*         vertices;
    gtf::scdr::SamplerState*         sampler;
};

#endif
