////////////////////////////////////////////////////////////////////////////////
// Copyright (c) Elektrobit Automotive GmbH
// Alle Rechte vorbehalten. All Rights Reserved.
//
// Information contained herein is subject to change without notice.
// Elektrobit retains ownership and all other rights in the software and each
// component thereof.
// Any reproduction of the software or components thereof without the prior
// written permission of Elektrobit is prohibited.
////////////////////////////////////////////////////////////////////////////////

#ifndef CUSTOM_EFFECT_RENDERER_GL_H_INCLUDED
#define CUSTOM_EFFECT_RENDERER_GL_H_INCLUDED

#include "CustomEffectRenderer.h"

class CustomEffectRendererGL : public CustomEffectRenderer
{
public:

    CustomEffectRendererGL(const gtf::viewfactory::ViewFactory& factory_, const CustomEffectCreateParams& desc_);

    virtual ~CustomEffectRendererGL();

private:

    static bool DrawEffect(void* renderFunctionContext_, gtf::scdr::GraphicsExecutionContext& context_);

private:

    virtual bool render(gtf::scdr::GraphicsContext& context_);

    virtual void setResources(gtf::scdr::ResourceBindingDescriptor* desc_, uint32_t textureCount_, uint32_t imageCount_);
    virtual const char* getVertexShader() const;
    virtual const char* getPixelShader() const;
    virtual uint32_t getSamplerCount(uint32_t textureCount_) const;

};

#endif // CUSTOM_EFFECT_RENDERER_GL_H_INCLUDED
